// MD2Model.h
#pragma once
#include "MD2Types.h"

struct MD2_POSITION_VERTEX
{
	union
	{
		struct
		{
			float x, y, z;
		};
		float a[3];
	};
};

struct MD2_TEXTURE_VERTEX
{
	union
	{
		struct
		{
			float s, t;
		};
		float a[2];
	};
};

class CMD2Model
{
public:
	int Load(std::istream& md2_stream, IDirect3DDevice9* device);
	int LoadFromFile(char* file_name, IDirect3DDevice9* device);
	
	IDirect3DVertexBuffer9* GetModelVB(int frame);
	IDirect3DVertexBuffer9* GetTextureVB(void);
	IDirect3DIndexBuffer9* GetModelIB(void);

	int GetVertCount(void);
	int GetTriangleCount(void);
	int GetFrameCount(void);
	char* GetFrameName(int frame);

	bool IsValid(void){return is_valid;}

protected:
	void GetHeader(std::istream& md2_stream);
	
	void GetFrameData(std::istream& md2_stream, IDirect3DDevice9* device);
	void GetIndexData(std::istream& md2_stream, IDirect3DDevice9* device);
	void GetTextureData(std::istream& md2_stream, IDirect3DDevice9* device);

	void ValidateHeader(void);
protected:
	bool is_valid;

	md2::header header;
	
	IDirect3DIndexBuffer9*  model_IB;
	IDirect3DVertexBuffer9* model_VB[512];
	IDirect3DVertexBuffer9* texture_VB;

	int used_VBs;
public:
	CMD2Model(void);
	~CMD2Model(void);
};

class MD2LoadException
{
public:
	MD2LoadException(char* error_msg)
	{
		error = error_msg;
	}

	char* error;
};