// MD2Types.h
#pragma once

typedef unsigned char byte;

namespace md2
{
struct header
{
	int magic_number;
	int version;

	int skinwidth;
	int skinheight;
	int framesize;

	int num_skin;
	int num_xyz;
	int num_st;
	int num_tris;
	int num_glcmds;
	int num_frames;

	int ofs_skins;
	int ofs_st;
	int ofs_tris;
	int ofs_frames;
	int ofs_glcmds;
	int ofs_end;
};

struct raw_vertex
{
	byte vertex[3];
	byte unused_normal_index;
};

struct frame
{
	float scale[3];
	float translate[3];
	char name[16];
	raw_vertex verticies[1];
};

struct triangle
{
	short vertex_indicies[3];
	short texture_indicies[3];
};
typedef short index_buffer[3];

struct tex_coord
{
	short s, t;
};

typedef char skin_name[64];

};