// Window.cpp
#include <windows.h>

#include "Window.h"

CWindow::CWindow(HINSTANCE hinstance, char* title, int size_x, int size_y, DWORD flags, WNDPROC window_proc_ptr)
{
	width = size_x;
	height = size_y;
	
	window_proc = window_proc_ptr;
	wndflags = flags;

	WNDCLASSEX wc;

	wc.cbClsExtra = 0; wc.cbWndExtra = 0;
	wc.cbSize = sizeof(WNDCLASSEX);
	wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.hCursor = LoadCursor(0, IDC_ARROW);
	wc.hIcon = LoadIcon(0, IDI_APPLICATION);
	wc.hIconSm = LoadIcon(0, IDI_APPLICATION);
	wc.hInstance = hinstance;
	wc.lpfnWndProc = window_proc;
	wc.lpszClassName = title;
	wc.lpszMenuName = 0;
	wc.style = CS_OWNDC;
	if (!RegisterClassEx(&wc))
		WndError("RegisterClassEx failed");
	hwnd = CreateWindowEx(0,title,title,wndflags|WS_VISIBLE,CW_USEDEFAULT,CW_USEDEFAULT,width, height,0,0,hinstance,0);
	if (!hwnd)
		WndError("CreateWindowEx failed");
}

CWindow::~CWindow(void)
{
}

CWindow::operator HWND(void) const
{
	return hwnd;
}

bool CWindow::is_popup(void)
{
	return ((wndflags & WS_POPUP) != 0);
}

bool CWindow::is_windowed(void)
{
	return ((wndflags & WS_POPUP) == 0);
}